local prots = {data.raw['transport-belt'], data.raw['underground-belt'], data.raw['splitter']}

-- local k_ef = 15/(40/3) -- some vibration!
local k_ef = 1

local speed_of_prot = {}
  -- belts
  speed_of_prot['transport-belt'] = {['transport-belt'] = 1, ['fast-transport-belt'] = 2, ['express-transport-belt'] = 3}
  -- underground belts
  speed_of_prot['underground-belt'] = {['underground-belt'] = 1, ['fast-underground-belt'] = 2, ['express-underground-belt'] = 3}
  -- splitters
  speed_of_prot['splitter'] = {['splitter'] = 1, ['fast-splitter'] = 2, ['express-splitter'] = 3}

-- animation_speed_coefficient = 32 -- must be by vanilla always 32
-- speed = 0.03125 is a tile/sec

function hoch_k (was_speed)
  local tier = was_speed / 0.03125 -- = 1 by first tier, 2 by second tier, 3 by third etc.
  return was_speed/tier * k_ef * 2^(tier-1) -- then we have 15, 30, 60 ... 
end

function hoch_n (was_speed)
  local tier = was_speed / 32
  return tier
end

for i, prot in pairs (prots) do
  for type_name, typ in pairs (speed_of_prot) do
    for prot_name, tier in pairs (typ) do
      if prot[prot_name] then
        local my_prot = prot[prot_name]
        my_prot.speed = hoch_k (my_prot.speed)
        -- my_prot.animation_speed_coefficient = k_ef * my_prot.animation_speed_coefficient
      end
    end
  end
end